



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>利用redis实现分布式锁</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">利用redis实现分布式锁</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-16 02:21:09 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>分布式锁一般有三种实现方式：</h1>
<p>1. 数据库乐观锁；</p>
<p>2.&nbsp;基于ZooKeeper的分布式锁；</p>
<p>3. 基于Redis的分布式锁；</p>
<p>这里大概说一下三种方式的优缺点，数据库乐观锁优点是实现简单，只需要for update关键词就可以实现，缺点是无法满足高并发量以及数据库读写频繁的系统</p>
<p>ZooKeeper分布式锁无论是从性能以及实现的功能来说都是非常优秀，只是在开发起来需要一定的基础，对新手可能不是很友好</p>
<p>而本文主要讲第三种利用redis实现分布式锁，优点是开发相对简单，能满足一定并发量的系统，缺点是存在线程争抢锁的问题，当并发量到达一定级别，多个线程去争抢同一个锁，对性能的影响较大</p>
<hr />
<h1>事务以及原子性</h1>
<p>虽然Redis是单线程运行，但是在分布式的情况下对同一资源进行操作还是会出现问题，下图是一个简单的例子</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1594654/201902/1594654-20190225200027451-564088486.png" /></p>
<p>所以一定要保证tomcat1以及tomcat2读写的原子性，既读与写要么都执行，要么都不执行。关于事务的原子性可以查询<a href="https://www.jianshu.com/p/cf57726e77f2" rel="external nofollow noreferrer">这里</a></p>
<p>那么如何保证呢，redis在2.6中加入了lua脚本功能可以轻松的解决这个问题，下面是一个简单的例子实现了上述的加100操作</p>
<div>
<pre class="prettyprint linenums">Jedis jedis = jedisPool.getResource();<br />
String script = "local a = redis.call('get', KEYS[0])   a = a + 100   <em>redis.call('set', a)</em><em>";

</em><em><em>jedis.eval(script, 1, rname+"Lock",RedisCacheFactory.FactoryUUID,"1000");</em></em></pre>
</div>
<hr />
<h1>分布式锁的具体实现</h1>
<p>大概讲一下思路：首先加锁的方式是向redis里存入一个KEY-VALUE，KEY存入的加锁对象可以是方法、类、数据等等，VALUE存入持有锁的节点（例如tomcat1）</p>
<p>大概整理了一下几个问题：</p>
<p>Q：为什么VALUE存入持有锁的节点</p>
<p>A：为的是防止A加的锁被B给解除，保证只有持有锁的节点才能解锁</p>
<p>Q：怎么存入持有锁的节点</p>
<p>A：这里只是我的思路是在tomcat启的时候生成一个uuid作为该tomcat的token存入到VALUE中</p>
<p>Q：怎么防止死锁</p>
<p>A：利用Redis设置键的过期时间</p>
<p>下面贴出部分代码，仅供参考</p>
<p>加锁</p>
<div>
<pre class="prettyprint linenums">JedisPool jedisPool = new JedisPool(new JedisPoolConfig(),RedisInstance.hostName,Integer.parseInt(RedisInstance.port),5000,password);<br />
Jedis jedis = jedisPool.getResource();<br />
// key1 : key值  argv1 :value值     argv2  :过期时间<br />
String script = "if redis.call('EXISTS',KEYS[1]) ==0 then redis.call('set',KEYS[1],ARGV[1]) redis.call('EXPIRE',KEYS[1],ARGV[2]) return 1  else return 0 end";<br />
long result =  (long) jedis.eval(script, 1, rname+"Lock",RedisCacheFactory.FactoryUUID,"1000");<br />
jedis.close();<br />
jedisPool.close();</pre>
</div>
<p>解锁</p>
<div>
<pre class="prettyprint linenums">JedisPool jedisPool = new JedisPool(new JedisPoolConfig(),RedisInstance.hostName,Integer.parseInt(RedisInstance.port),5000,password);<br />
Jedis jedis = jedisPool.getResource();<br />
String script = "if redis.call('EXISTS',KEYS[1]) ==1 and redis.call('GET',KEYS[1])==ARGV[1]  then return redis.call('del',KEYS[1]) else return 0 end";<br />
long result =  (long) jedis.eval(script, 1, rname+"Lock",RedisCacheFactory.FactoryUUID);<br />
jedis.close();<br />
jedisPool.close();</pre>
</div>
<p>以上仅个人意见，如有错误的地方，还请各位海涵。</p>
<p>后面可能会整合这次缓存改造的所有环节发出来给大家参考 一下</p>
<p>补充说明一下:lua操作redis时如果操作多个key不在同一节点下会出错，原因是因为Cluster会将数据自动分布到不同的节点(虚拟的16384个slot，具体看<a href="https://redis.io/commands/cluster-keyslot" rel="external nofollow noreferrer">这里</a>)。</p>
<p>解决办法 后面会贴出详细教程</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxdykz9.html">2017预防bug的重要性</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gpx279.html">Tomcat服务无法开启，点击start不一会就变成stopped</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1pop2q.html">Android&colon; 解决ADB server didn&amp;&num;39&semi;t ACK</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r7wrd8.html">vim的一些配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q21ovx8.html">灵活QinQ配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxm2oe9.html">HTML中的target&lpar;&lowbar;self&comma;&lowbar;blank&rpar;用法总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm1ej19.html">解决在 MVC 　局部视图中加载　ueditor 编辑器时， 编辑器加载不出的 bug</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmxov09.html">让WPF的Popup不总置顶的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpoo0vq.html">Python 3 读写文件的简单方法！</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zlw109.html">Core Location实现定位</a>
		</li>
						<li><a href="https://www.batexi.com/a/9502egv8.html">jmeter学习笔记（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwj00y8.html">Java Lambda expression</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r540leq.html">MyBatis全局配置文件的各项标签3</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5kmz4q.html">java内存性能调优编码注意</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wgm6nq.html">tk&period;mybatis通用工具采坑记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jooy0q.html">Redis 系列之CentOS下Redis的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdvjge9.html">【HDOJ图论题集】【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p26r08.html">django框架  input 文本框 单选框 多选框 上传文件 等数据传输后台的程序 request&period;getlist接收多个结果  obj&period;chunks 用于文件传输  enctype&equals;&amp;quot&semi;multipart&sol;form-data文件传输必备表头</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvel0zo9.html">C&num;  winfrom DataGridView用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj2l07q.html">swift动态库与use&lowbar;frameworks</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95ggxgvq.html">Notes on Operating System</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jjy13q.html">php类自动加载</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wwym0q.html">ASCII记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv222xy9.html">Windows &plus; Apache  &plus; WSGI 部署Django</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rr2039.html">只要一行代码求一串字符中某字符（串）出现次数，c&num;</a>
			</li>
						<li><a href="https://www.batexi.com/a/96003w39.html">ubuntu设置ssh登录</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wwjwwq.html">Mybatis的JDBC提交设置&sol;关闭mysql自动提交------关于mysql自动提交引发的惨剧</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv220vy9.html">linux下tomcat服务器的相关命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m22w72q.html">Mac 系统安装教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjj5w09.html">Android WebView 加载超长 JS 数据</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
